import sys


class lz77: #classe para comprimir uma sequência de caracters usando LZ77
    def __init__(self, window_size = 65535, buffer_size=255):
        self.window_size = window_size
        self.buffer_size = buffer_size


    def encode(self, string): #codificar o LZ77
        ret = [] #lista de tuplas
        i = 0
        aux = "1"
        while i < len(string) and aux == "1":
            begin_window = i-self.window_size
            if begin_window < 0:
                begin_window = 0
            window = string[begin_window:i]
            buffer = string[i:i+self.buffer_size]

            if buffer != '':
                aux = input("Escreva '1' se você deseja seguir com a codificação." + "\n")
                print("*" * 80)

            tuple = (0, 0, string[i])
            for size in range(len(buffer), 0, -1):
                index = window.rfind(buffer[0:size])
                if index >= 0:
                    literal = string[-1]
                    tuple = (len(window)-index, size - 1, literal) #(posição, tamanho, caracter)
                    if i + size < len(string):
                        literal = string[i+size]
                        tuple = (len(window)-index, size, literal) #(posição, tamanho, caracter)
                    break
            i = i + tuple[1] + 1
            ret = ret + [tuple] #lista de tuplas

            print("Buffer: " + buffer)
            if str(buffer[0:size]) != str(tuple[2]):
                print("Janela: " + string[0:i - 1 - len(buffer[0:size])])
                print("Match: " + buffer[0:size])
            else:
                print("Janela: " + string[0:i - 1])
                print("Match: " + "-")

            print("Caracter adicionado: " + str(tuple[2]))
            print("Saída: " + str(tuple))
            print("Codificação parcial: " + str(ret))
            print("*"*80)
            '''if str(tuple[2]) != '':
                aux = input("Escreva '1' se você deseja seguir com a codificação." + "\n")
                print("*" * 80)'''
        if aux != "1":
            print("Código encerrado pelo usuário.")
            print("*"*80)
        return ret



    def decode(self, list):
        ret = ''
        aux = "1"
        while aux == "1":
            for i in range(len(list)):  # esse list é uma lista de tuplas. saída do encode.
                tupla = list[i]
                pos = len(ret) - int(tuple(tupla)[0])
                ret = ret + ret[pos:pos + tuple(tupla)[1]] + tuple(tupla)[2]
                print("Codificando: " + str(tupla) + "\n" + "Decodificado: " + ret[pos:pos + tuple(tupla)[1]] + tuple(tupla)[2])
                print("Decodificação parcial: " + ret)
                print("*" * 80)
                if i == len(list) - 1:
                    aux = ""
                else:
                    aux = input("Escreva '1' se você deseja seguir com a decodificação." + "\n")
                    print("*" * 80)
                    if aux != "1":
                        print("Código encerrado pelo usuário.")
                        print("*" * 80)
                        break
        return ret

if __name__ == "__main__":
    print("="*33)
    print("Codificador e Decodificador LZ77")
    print("="*33)
    codificar_decodificar = input("Você deseja codificar (1) ou decodificar (2)? ")

    if codificar_decodificar == "1":
        string_encode = input("String para ser codificada: ")
        print("*" * 80)
        encoder = lz77(len(string_encode), len(string_encode))
        encoded = encoder.encode(string_encode)
        print("String: " + string_encode)
        print("Codificado: " + str(encoded))
        print("*" * 80)
        taxa_compressao = (8*len(string_encode))/(24*(len(encoded))) #considerando que um inteiro será cosificado com 8 bits
        print("Tamanho da string de entrada: " + str(8*len(string_encode)) + ' bits')
        print("Tamanho da saída do codificador: " + str(8*3*int(len(encoded))) + ' bits')
        print("Taxa de compactação: " + str(round(taxa_compressao, 2)))
        sys.exit()

    if codificar_decodificar == "2":
        qnt_tuplas = int(input("Quantas tuplas você deseja decodificar? "))
        print("*" * 80)
        lista = []
        for i in range(qnt_tuplas):
            print("TUPLA " + str(i))
            posicao = int(input("Posição: "))
            tamanho = int(input("Tamanho: "))
            caracter_codificado = str(input("Caracter: "))
            print("*" * 80)
            tupla = (posicao, tamanho, caracter_codificado)
            lista = lista + [tupla]
        print("Para decodificar: " + str(lista))
        print("*" * 80)
        decoder = lz77(8, 4)
        decoded = decoder.decode(lista)
        print("Lista de tuplas: " + str(lista))
        print("Decodificado: " + str(decoded))
        sys.exit()

    else:
        print("Entrada inválida. Tente novamente.")



